#include <sys/cdefs.h>

#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

static void usage(void);
extern char **environ;


int
main(int argc, char **argv)
{
  unsigned int memsize;
  unsigned int p = 0; /* offset from beginning of boundary */
  char *memstart;
  int ch;
  char testdata = 0xff;

  while ((ch = getopt(argc, argv, "m:")) != -1) {
    switch (ch) {
    case 'm':
      memsize = atoi(optarg);
      memsize *= 1024 * 1024;
      break;

    default:
      usage();
    }

  }
  argc -= optind;
  argv += optind;

  /* Allocate memory. */
  memstart = malloc(memsize * sizeof(char));
  if (NULL == memstart) {
    printf("useMemory: couldn't allocate memory!");
    exit(2);
  }
  printf("useMemory: allocated %ld bytes of memory\n", memsize);

  while (p < memsize) {
    memstart[p] = 0xde;
    memstart[p+1] = 0xad;
    memstart[p+2] = 0xbe;
    memstart[p+3] = 0xef;
    if (0 == (p % 1048576))
      printf("useMemory: writing to %ld / %ld bytes at %p (%dddd)\n", p, memsize, 
	     &memstart[p], memstart[p], memstart[p+1], memstart[p+2], memstart[p+3]);
    p += 1024; /* this really should be set 
		  to the page size */
  }

  for (;;)
    sleep(10);

  exit(0);
}

static void
usage(void)
{
  (void) fprintf(stderr, "%s\n",
		 "usage: useMemory [-m memsize]");
  exit(1);
} 
